#!/bin/bash

shopt -s extglob

# Expect arguments of this form:
#
#    z=[3,4,5,6]
 
function main
{
    parse_args $*
 
    i=0
    while (($i<$variable_counter))
    do
                display $i
                i=$((i+1))
    done
 
    exit 0
 
    multiply 20  1 $T
    add      21 20 $S
 
    multiply 30  1 $V
    add      31 30 $U
 
    conjugate 32 31
    conjugate 33 32
    conjugate 34 33
 
    multiply 40 32 33
    multiply 41 40 34
 
    multiply 42 41 21
 
    multiply 43 41 31
 
    echo "numerator:"
    display 42
 
    echo "denominator:"
    display 43
}
 
function copy
{
    typeset o=$1
    typeset i=$2
 
    a[o]=$(( a[i] ))
    b[o]=$(( b[i] ))
    e[o]=$(( e[i] ))
    f[o]=$(( f[i] ))
}
 
function negate
{
    typeset o=$1
    typeset i=$2
 
    a[o]=$(( -a[i] ))
    b[o]=$(( -b[i] ))
    e[o]=$(( -e[i] ))
    f[o]=$(( -f[i] ))
}
 
function add
{
    typeset o=$1
    typeset i=$2
    typeset j=$3
 
    a[o]=$(( a[i] + a[j] ))
    b[o]=$(( b[i] + b[j] ))
    e[o]=$(( e[i] + e[j] ))
    f[o]=$(( f[i] + f[j] ))
}
 
function multiply
{
    typeset o=$1
    typeset i=$2
    typeset j=$3
 
    a[o]=$(( a[i]*a[j] - 4*b[i]*f[j] - 2*e[i]*e[j] - 4*f[i]*b[j] - 16*f[i]*f[j] ))
    b[o]=$(( a[i]*b[j] + b[i]*a[j] - 2*e[i]*f[j] - 2*f[i]*e[j] ))
    e[o]=$(( a[i]*e[j] + 2*b[i]*b[j] + e[i]*a[j] + 8*b[i]*f[j] + 4*e[i]*e[j] + 8*f[i]*b[j] + 28*f[i]*f[j] ))
    f[o]=$(( a[i]*f[j] + b[i]*e[j] + e[i]*b[j] + f[i]*a[j] + 4*e[i]*f[j] + 4*f[i]*e[j] ))
}
 
function conjugate
{
    typeset o=$1
    typeset i=$2
 
    a[o]=$(( a[i] + 4*e[i] ))
    b[o]=$(( 3*b[i] + 10*f[i] ))
    e[o]=$(( -e[i] ))
    f[o]=$(( -b[i] - 3*f[i] ))
}
 
function parse_args
{
    for arg
    do
                variable=${arg%=*}
                value=${arg#*=[}
                xa=${value%%,*}
                value=${value#*,}
                xb=${value%%,*}
                value=${value#*,}
                xe=${value%%,*}
                value=${value#*,}
                xf=${value%]}
                allocate $variable $xa $xb $xe $xf
    done
}
 
typeset -i variable_counter=0
 
function allocate
{
    typeset var_name=$1
 
    typeset a_local=$2
    typeset b_local=$3
    typeset e_local=$4
    typeset f_local=$5
 
    typeset -i n=$variable_counter
 
    a[n]=$a_local
    b[n]=$b_local
    e[n]=$e_local
    f[n]=$f_local
 
    eval var_${variable}=$n
    var[n]=$variable
 
    variable_counter=n+1
}
 
function display
{
    typeset i=$1
    echo "${var[i]}=[${a[i]},${b[i]},${e[i]},${f[i]}]"
}
 
main $*
